/*
 *	dirtime.h
 */

#ifndef DIRTIME_H_
#define DIRTIME_H_

#ifdef __cplusplus
extern "C" {
#endif



#ifndef SET_LAST_WRITE_TIME
#define SET_LAST_WRITE_TIME		3
#define GET_LAST_WRITE_TIME		4
#define SET_LAST_ACCESS_TIME	5
#define GET_LAST_ACCESS_TIME	6
#define SET_CREATION_TIME		7
#define GET_CREATION_TIME		8
#endif /* SET_LAST_WRITE_TIME */

BOOL WINAPI SetDirectoryTimeA(LPCSTR path, const FILETIME *pCreationTime,
		const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime);

BOOL WINAPI SetDirectoryTimeW(LPCWSTR path, const FILETIME *pCreationTime,
		const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime);

#ifdef UNICODE
#define SetDirectoryTime	SetDirectoryTimeW
#else
#define SetDirectoryTime	SetDirectoryTimeA
#endif // !UNICODE


BOOL WINAPI GetDirectoryTimeA(LPCSTR path, FILETIME *pCreationTime,
		FILETIME *pLastAccessTime, FILETIME *pLastWriteTime);

BOOL WINAPI GetDirectoryTimeW(LPCWSTR path, FILETIME *pCreationTime,
		FILETIME *pLastAccessTime, FILETIME *pLastWriteTime);

#ifdef UNICODE
#define GetDirectoryTime	GetDirectoryTimeW
#else
#define GetDirectoryTime	GetDirectoryTimeA
#endif // !UNICODE



/*-- for internal use -- ==> */
BOOL SetDirectoryTime9x(const char *path, const FILETIME *pCreationTime,
		const FILETIME *pLastAccessTime, const FILETIME *pLastWriteTime);

BOOL SetDirectoryTimeDos(const char *fullpath, int func,
		WORD dosdate, WORD dostime, WORD millisec);

BOOL GetDirectoryTime9x(const char *path, FILETIME *pCreationTime,
		FILETIME *pLastAccessTime, FILETIME *pLastWriteTime);

BOOL GetDirectoryTimeDos(const char *fullpath, int func,
		WORD *dosdate, WORD *dostime, WORD *millisec);
/* <== -- for internal use --*/




#ifndef FT_ROUND_UP
#define FT_ROUND_UP		1
#define FT_ROUND_NONE	0
#define FT_ROUND_DOWN	(-1)
#endif /* FT_ROUND_UP */

BOOL WINAPI ktDosDateTimeToFileTime(WORD dosdate, WORD dostime, WORD millisec,
		FILETIME *pFileTime);

BOOL WINAPI ktFileTimeToDosDateTime(const FILETIME *pFileTime,
		WORD *pdosdate, WORD *pdostime, WORD *pmillisec, int roundmode);

BOOL WINAPI ktDosDateTimeToLocalTime(WORD dosdate, WORD dostime, WORD millisec,
		SYSTEMTIME *pLocalTime);

BOOL WINAPI ktLocalTimeToDosDateTime(const SYSTEMTIME *pLocalTime,
		WORD *pdosdate, WORD *pdostime, WORD *pmillisec);

BOOL WINAPI ktLocalTimeToFileTime(const SYSTEMTIME *pLocalTime,
		FILETIME *pFileTime);

BOOL WINAPI ktFileTimeToLocalTime(const FILETIME *pFileTime,
		SYSTEMTIME *pLocalTime);


#ifdef __cplusplus
}
#endif

#endif /* DIRTIME_H_ */
