/*
 * k32undoc.h - Kernel32.dll Undocumented APIs
 */

#ifndef K32UNDOC_H_
#define K32UNDOC_H_

#ifdef __cplusplus
extern "C" {
#endif


/*
 * VxDCall APIs
 *	ordinal # 1 - 9
 */
WINBASEAPI DWORD WINAPI VxDCall0(DWORD);
WINBASEAPI DWORD WINAPI VxDCall1(DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall2(DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall3(DWORD, DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall4(DWORD, DWORD, DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall5(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall6(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall7(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);
WINBASEAPI DWORD WINAPI VxDCall8(DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD, DWORD);


/*
 * User32 String APIs
 *	ordinal # 10 - 16
 */
WINBASEAPI BOOL WINAPI K32CharToOemA(LPCSTR, LPSTR);
WINBASEAPI BOOL WINAPI K32CharToOemBuffA(LPCSTR, LPSTR, DWORD);
WINBASEAPI BOOL WINAPI K32OemToCharA(LPCSTR, LPSTR);
WINBASEAPI BOOL WINAPI K32OemToCharBuffA(LPCSTR, LPSTR, DWORD);
WINBASEAPI int WINAPI  K32LoadStringA(HINSTANCE, UINT, LPSTR, int);
WINBASEAPI int WINAPIV K32wsprintfA(LPSTR, LPCSTR, ...);
WINBASEAPI int WINAPI  K32wvsprintfA(LPSTR, LPCSTR, va_list arglist);


/*
 * FileHandle APIs
 *	ordinal # 20 - 22
 */
WINBASEAPI HANDLE WINAPI DosFileHandleToWin32Handle(WORD);
WINBASEAPI WORD WINAPI Win32HandleToDosFileHandle(HANDLE);

WINBASEAPI BOOL WINAPI DisposeLZ32Handle(HANDLE);


/*
 * Global Memory APIs
 *	ordinal # 24 - 32
 */
WINBASEAPI HGLOBAL WINAPI GlobalAlloc16(WORD, DWORD);
WINBASEAPI DWORD   WINAPI GlobalLock16(HGLOBAL);
WINBASEAPI BOOL    WINAPI GlobalUnlock16(HGLOBAL);
WINBASEAPI void    WINAPI GlobalFix16(HGLOBAL);
WINBASEAPI void    WINAPI GlobalUnfix16(HGLOBAL);
WINBASEAPI DWORD   WINAPI GlobalWire16(HGLOBAL);
WINBASEAPI BOOL    WINAPI GlobalUnWire16(HGLOBAL);
WINBASEAPI HGLOBAL WINAPI GlobalFree16(HGLOBAL); 
WINBASEAPI DWORD   WINAPI GlobalSize16(HGLOBAL);

/* Global Memory Flag(s) */
#define GMEM_DOS	0x8000


/*
 * Environment API(s)
 *	ordinal # 34
 */
WINBASEAPI LPVOID WINAPI GetSystemEnvironmentStrings(VOID);
//WINBASEAPI LPVOID WINAPI GetWin16DOSEnv(VOID);
#define GetWin16DOSEnv()	GetSystemEnvironmentStrings()


/*
 * DLL APIs
 *	ordinal # 35 - 37
 */
WINBASEAPI HINSTANCE WINAPI LoadLibrary16(LPCSTR);
WINBASEAPI void WINAPI FreeLibrary16(HINSTANCE);
WINBASEAPI FARPROC WINAPI GetProcAddress16(HINSTANCE, LPCSTR);


/*
 * WOW APIs
 *	ordinal # 54 - 70
 */
#include <wownt32.h>

WINBASEAPI DWORD WINAPI K32WOWCallback16(DWORD, DWORD);
WINBASEAPI BOOL  WINAPI K32WOWCallback16Ex(DWORD, DWORD, DWORD, PVOID, PDWORD);

WINBASEAPI LPVOID WINAPI K32WOWGetVDMPointer(DWORD, DWORD, BOOL);

WINBASEAPI HANDLE WINAPI K32WOWHandle32(WORD, WOW_HANDLE_TYPE);
WINBASEAPI WORD WINAPI K32WOWHandle16(HANDLE, WOW_HANDLE_TYPE);

WINBASEAPI WORD  WINAPI K32WOWGlobalAlloc16(WORD, DWORD);
WINBASEAPI DWORD WINAPI K32WOWGlobalLock16(WORD);
WINBASEAPI BOOL  WINAPI K32WOWGlobalUnlock16(WORD);
WINBASEAPI WORD  WINAPI K32WOWGlobalFree16(WORD);

WINBASEAPI DWORD WINAPI K32WOWGlobalAllocLock16(WORD, DWORD, WORD);
WINBASEAPI WORD  WINAPI K32WOWGlobalUnlockFree16(DWORD);
WINBASEAPI DWORD WINAPI K32WOWGlobalLockSize16(WORD, PDWORD);

WINBASEAPI VOID WINAPI K32WOWYield16(VOID);
WINBASEAPI VOID WINAPI K32WOWDirectedYield16(WORD);

WINBASEAPI LPVOID WINAPI K32WOWGetVDMPointerFix(DWORD, DWORD, BOOL);
WINBASEAPI VOID WINAPI K32WOWGetVDMPointerUnfix(DWORD);

WINBASEAPI DWORD WINAPI K32WOWGetDescriptor(DWORD, DWORD);


#ifdef __cplusplus
}
#endif

#endif /* K32UNDOC_H_ */
