#
# makefile for touch
#

cc = cl /nologo
link = link /nologo
cflags = /O1 /W3


objs = touch9x.obj dirtime.obj vwinfunc.obj k32undoc.lib
objsw = touch.obj dirtimewe.obj vwinfunc.obj k32undoc.lib
dllobjs = dirtime.obj dirtimewd.obj tinydll.obj vwinfunc.obj k32undoc.lib dirtime.res

all : touch9x.exe touch.exe dirtime.dll

#
# ANSI exe
#
touch9x.exe : $(objs)
	$(link) $** shlwapi.lib /out:$@ /opt:nowin98 /merge:.rdata=.text

touch9x.obj : touch.c dirtime.h vwinfunc.h k32undoc.h
	$(cc) /Fo$@ $(cflags) /MD /c touch.c


#
# UNICODE exe
#
touch.exe : $(objsw)
	$(link) $** shlwapi.lib /out:$@ /opt:nowin98 /merge:.rdata=.text

touch.obj : touch.c dirtime.h vwinfunc.h k32undoc.h
	$(cc) /Fo$@ $(cflags) /DUNICODE /D_UNICODE /MD /c touch.c

dirtimewe.obj : dirtime.c dirtime.h
	$(cc) /Fo$@ $(cflags) /DUNICODE /D_UNICODE /DNOWIN9X /Zl /c dirtime.c


#
# DLL
#
dirtime.dll : $(dllobjs) dirtime.def
	$(link) /DLL $(dllobjs) kernel32.lib /out:$@ /def:dirtime.def /opt:nowin98 /merge:.rdata=.text

tinydll.obj : tinydll.c
	$(cc) /LD $(cflags) /c $*.c

dirtimewd.obj : dirtime.c dirtime.h
	$(cc) /Fo$@ $(cflags) /DUNICODE /D_UNICODE /DNO_TIMECONV /Zl /c dirtime.c

dirtime.res : dirtime.rc


# /Zl : NODEFAULTLIB
.c.obj:
	$(cc) $(cflags) /Zl /c $*.c

dirtime.obj : dirtime.c dirtime.h vwinfunc.h k32undoc.h

vwinfunc.obj : vwinfunc.c vwinfunc.h k32undoc.h


k32undoc.lib : k32undoc.def
	lib -machine:i386 -def:$*.def -nologo


clean :
	del $(objs) $(objsw) $(dllobjs)
	del k32undoc.exp dirtime.exp
	del touch9x.exe touch.exe dirtime.dll dirtime.lib

